10 '  FRAME ANALYSIS - KETCHUM 1980
20  '
30 '  HEADINGS AND PARAMETERS
40 DEFINT I-N:CLEAR 120
50 CLS:PRINT "NONLINEAR FRAME ANALYSIS - ITERATIVE METHOD":PRINT
60 RESTORE 3620
70 PRINT "This program iterates until the change in deflections is small.":PRINT
80 PRINT "Data for different examples may be changed by changing the RESTORE statement
90 PRINT "in line 60 refering to the start of the data.":PRINT
100 READ A$:PRINT A$
110 PRINT B$
120 READ M3,JF,EL
130 PRINT "NUMBER OF FRAME MEMBERS = ";M3;" JOINTS = ";JF
140 PRINT "MODULUS OF ELASTICITY = ";EL
150 DIM X(M3,5),Y(M3,5),UV(M3,5),UH(M3,5),PV(M3,5),PH(M3,5)
160 DIM AT(M3,3),MK(M3,2),ND(JF,3),IR(6),AF(M3,3),CK(JF,2)
170 DIM A$(M3),B$(M3),MN(M3),NS(M3),S2(6),U(6),P(6),TH(M3)
180 DIM BM(6),SM(6,2),SB(6,2),S1(6,6),FM(M3,2),T(M3,4),DS(JF,2)
190 FOR I=1 TO JF:FOR J=1 TO 3:ND(I,J)=1:NEXT J,I
200 XX=0
210 '
220 '  MAIN PROGRAM
230 IG=1
240 GOSUB 1250 '  Coordinates.
250 GOSUB 580  ' Properties, Member Incidencies, Code numbers.
260 GOSUB 1050 ' Band width
270 GOTO 290  'Skip member property revision
280 GOSUB 1400 'Member revison
290 PRINT:PRINT "Assemble matrix"
300 FOR MI=1 TO M3: 
310 GOSUB 1340 ' Dimensions
320 GOSUB 2790 '  Stiffness
330 GOSUB 3050 '  Assembly
340 NEXT MI: PRINT
350 GOSUB 3180 '  Solve Matrix.
360 IF XX=1 THEN 400  
370 FOR I=1 TO M3:FM(I,1)=0:FM(I,2)=0:NEXT
380 GOSUB 1500 ' Data Statements
390 GOSUB 1840 ' Load summary
400 GOSUB 3360 '  Second part of solver
410 GOSUB 1950 '  Deflections.
420 IF IG=1 THEN 450
430 PRINT:INPUT "PRINT MEMBER FORCES (Y OR ENTER) ";A$
440 IF A$="" OR A$="N" THEN 520
450 CLS: PRINT "MEMBER FORCES IN FRAME - PASS NO. ";IG
460 FOR MI=1 TO M3
470 GOSUB 1340 ' Dimensions
480 GOSUB 2790 ' Stiffness matrix
490 GOSUB 2050 ' Forces
500 NEXT MI
510 GOSUB 2610 ' Statics Check.
520 GOSUB 2690 ' Revise coordinates
530 GOSUB 3590 ' Get this dimension statement down thw line
540 IG=IG+1
550 GOTO 280  'Back to member revision and next cycle
560 END
570 '
580 PRINT "FRAME DATA ":PRINT
590 PRINT "MEMBER PROPERTIES"
600 PRINT "TYPE       AREA         I     SHEAR AREA"
610 READ I:IF I=0 THEN 660  
620 READ AT(I,1),AT(I,2),AT(I,3)
630 PRINT USING "### ";I;
640 PRINT USING "######.#### ";AT(I,1);AT(I,2);AT(I,3)
650 GOTO 610  
660 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS:PRINT
670 PRINT "MEMBER INCIDENCES AND TYPES ":PRINT "MEMBER  JT. TO JT.  TYPE"
680 FOR I=1 TO M3:READ II,MK(I,1),MK(I,2),IT
690 PRINT USING "####  ";I,MK(I,1),MK(I,2),IT
700 AF(I,1)=AT(IT,1):AF(I,2)=AT(IT,2):AF(I,3)=AT(IT,3)
710 NEXT
720 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS:PRINT
730 FOR I=1 TO M3:IQ=0:NEXT
740 PRINT "SUPPORTS AND RELEASES":PRINT "JOINT   X    Y   PHI"
750 READ I:IF I=0 THEN 800  
760 READ K1,K2,K3
770 PRINT USING "###  ";I;K1;K2;K3
780 ND(I,1)=K1:ND(I,2)=K2:ND(I,3)=K3
790 GOTO 750  
800 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS:PRINT
810 N1=0
820 FOR I=1 TO JF
830 N1=N1+1
840 FOR J=1 TO 3
850 IF ND(I,3)=2 THEN 860  ELSE 910  
860 ND(I,1)=N1:N1=N1+1:ND(I,2)=N1:N1=N1+1:ND(I,3)=N1
870 ND(I+1,1)=ND(I,1)
880 ND(I+1,2)=ND(I,2):N1=N1+1
890 ND(I+1,3)=N1:N1=N1+1
900 I=I+1:GOTO 950  
910 IF ND(I,J)=0 THEN 940  
920 ND(I,J)=N1
930 N1=N1+1
940 NEXT J
950 N1=N1-1:NEXT I
960 PRINT "THERE ARE ";N1;" EQUATIONS"
970 DIM F(N1),D1(N1),F3(N1)
980 PRINT "CODE NUMBERS ": PRINT "JOINT  X    Y    PHI"
990 FOR I=1 TO JF
1000 PRINT USING "###  ";I;ND(I,1);ND(I,2);ND(I,3)
1010 NEXT
1020 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS:PRINT
1030 RETURN
1040 '
1050 IB=0:PRINT "CALCULATE BAND WIDTH "
1060 FOR M1= 1 TO M3
1070 JN=MK(M1,1):JM=MK(M1,2):IR(1)=ND(JN,1)
1080 IR(2)=ND(JN,2):IR(3)=ND(JN,3)
1090 IR(4)=ND(JM,1):IR(5)=ND(JM,2):IR(6)=ND(JM,3)
1100 MI=1000:MA=0
1110 FOR I=1 TO 6
1120 IF IR(I)=0 THEN 1150 
1130 IF IR(I)>MA THEN MA=IR(I)
1140 IF IR(I)<MI THEN MI=IR(I)
1150 NEXT I
1160 IC=MA-MI+1
1170 PRINT IC;
1180 IF IC>IB THEN IB=IC
1190 NEXT M1
1200 PRINT:PRINT "BAND WIDTH = ";IB
1210 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS:PRINT
1220 DIM S(N1,IB)
1230 RETURN
1240 '
1250 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS:PRINT
1260 PRINT "JOINT COORDINATES ":PRINT "JOINT       X        Y"
1270 FOR I=1 TO JF:READ II,CA,CB:CK(I,1)=CA:CK(I,2)=CB
1280 PRINT USING "### ##,###.## ##,###.## ";I;CA;CB
1290 DS(I,1)=CA:DS(I,2)=CB:NEXT
1300 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS:PRINT
1310 RETURN
1320 '
1330 '  Dimensions
1340 JN=MK(MI,1):JM=MK(MI,2):X=CK(JM,1)-CK(JN,1)
1350 Y=CK(JM,2)-CK(JN,2)
1360 AL=SQR(X*X+Y*Y):A=AF(MI,1):XI=AF(MI,2):AV=AF(MI,3)
1370 FOR I=1 TO 3:IR(I)=ND(JN,I):IR(I+3)=ND(JM,I):NEXT I
1380 RETURN
1390 '
1400 INPUT "REVISE MEMBER PROPERTIES (Y OR ENTER) ";A$
1410 IF A$="" THEN 1470
1420 PRINT:INPUT "RESCALE ALL E VALUES BY ";RS
1430 INPUT "NUMBER OF MEMBERS = ";NK
1440 FOR I=1 TO NK:INPUT "MEMBER NO. ";MM
1450 FOR J=1 TO 3:AF(MI,J)=AF(MI,J)*RS:NEXT J
1460 NEXT I
1470 RETURN
1480 '
1490 ' Read load data statements
1500 FOR I=1 TO M3:FOR J=1 TO 4:T(I,J)=0:NEXT J,I
1510 FOR I=1 TO M3:FM(I,1)=0:FM(I,2)=0:NEXT I
1520 FOR I=1 TO M3:FOR J=1 TO 4:T(I,J)=0:NEXT J,I
1530 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS:PRINT
1540 READ NL,A$,JL,MU
1550 PRINT "LOAD CASE NUMBER ";NL:PRINT
1560 PRINT "DESCRIPTION - ";A$:PRINT
1570 PRINT "NO. OF JOINT LOADS = ";JL
1580 PRINT "NUMBER OF MEMBERS WITH UNIFORM LOADS ";MU
1590 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS:PRINT
1600 CLS
1610 IF JL=0 THEN 1690 
1620 PRINT "JOINT LOADS":PRINT "JOINT    X      Y     MOMENT "
1630 FOR J=1 TO JL
1640 READ I,F(ND(I,1)),F(ND(I,2)),F(ND(I,3))
1650 PRINT USING "### ";I;
1660 PRINT USING "####.## ";F(ND(I,1));F(ND(I,2));F(ND(I,3))
1670 NEXT
1680 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS:PRINT
1690 IF MU=0 THEN 1800 
1700 PRINT "MEMBERS WITH UNIFORM LOADS"
1710 PRINT "MEMBER     HOR. LOAD  VERT. LOAD"
1720 FOR J=1 TO MU:READ IQ,UH(IQ,1),UV(IQ,1)
1730 PRINT USING "####   #,####.##    #,###.##";IQ,UH(IQ,1),UV(IQ,1)
1740 MI=IQ:GOSUB 1340 
1750 RV=UV(IQ,1)*X/2:RH=UH(IQ,1)*Y/2
1760 RM=RV*X/6:RN=RH*Y/6:FM(IQ,1)=RM+RN:FM(IQ,2)=-RM-RN
1770 F(ND(JN,1))=F(ND(JN,1))+RH:F(ND(JM,1))=F(ND(JM,1))+RH
1780 F(ND(JN,2))=F(ND(JN,2))+RV:F(ND(JM,2))=F(ND(JM,2))+RV
1790 F(ND(JN,3))=F(ND(JN,3))+RM+RN:F(ND(JM,3))=F(ND(JM,3))-RM-RN
1800 T(IQ,1)=RH:T(IQ,2)=RV:T(IQ,3)=RH:T(IQ,4)=RV
1810 NEXT J
1815 RETURN
1820 '
1830 ' Summary of loads
1840 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS:PRINT
1850 PRINT:PRINT "SUMMARY OF LOADS"
1860 PRINT "JOINT       X         Y        MOMENT"
1870 FOR I=1 TO N1:D1(I)=F(I):F3(I)=F(I):NEXT:F(0)=0
1880 FOR I= 1 TO JF:PRINT USING "### ";I;:FOR J=1 TO 3
1890 PRINT USING "###,###.##  ";F(ND(I,J));
1900 NEXT J:PRINT
1910 NEXT I
1920 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS:PRINT
1930 RETURN
1940 '
1950 PRINT:PRINT "DEFLECTIONS - PASS NO. ";IG"
1960 PRINT"JOINT   X       Y      PHI"
1970 D1(0)=0:FOR I=1 TO JF:PRINT USING "### ";I;:FOR J=1 TO 3
1980 PRINT USING "###.#### ";D1(ND(I,J))/EL;
1990 NEXT J:PRINT
2000 NEXT I
2010 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS
2020 RETURN
2030 '
2040 '  Member forces
2050 FOR I=1 TO 6:F1(I)=D1(IR(I)):NEXT
2060 FOR I=1 TO 6:S2(I)=0:FOR J=1 TO 6
2070 S2(I)=S2(I)+S1(I,J)*F1(J):NEXT J,I
2080 FOR I=1 TO 6:F(IR(I))=F(IR(I))-S2(I):NEXT
2090 S2(1)=S2(1)+T(MI,1):S2(2)=S2(2)-T(MI,2)
2100 S2(4)=S2(4)+T(MI,3):S2(5)=S2(5)-T(MI,4)
2110 DM=X/AL:DN=Y/AL
2120 T1=(S2(1)*DM+S2(2)*DN):T2=(S2(4)*DM+S2(5)*DN)
2130 IF MN(MI)>0 THEN 2200 
2140 U=UV(MI,1)*DM*DM+UH(MI,1)*DN*DN
2150 SM=U*AL*AL/8:PL=S2(3)-FM(MI,1):PR=FM(MI,2)-S2(6)
2160 SL=U*AL/2+(PR-PL)/AL:CC=SM+(PR+PL)/2
2170 SR=-(PL-PR)/AL-U*AL/2
2180 CL=3*SM/4+PL+(PR-PL)/4:CR=3*SM/4+PL+3*(PR-PL)/4
2190 GOTO 2430 
2200 TU=0:AU=0:SN=0
2210 FOR I=1 TO NS(MI)
2220 U(I)=UV(MI,I)*DM*DM+UH(MI,I)*DN*DN
2230 P(I)=PV(MI,I)*DM+PH(MI,I)*DN
2240 TB(I)=UV(MI,I)*DN*DM+UH(MI,I)*DM*DN
2250 P2(I)=PV(MI,I)*DN+PH(MI,I)*DM
2260 IF DM>.707 THEN DI(I)=X(MI,I)/DM ELSE DI(I)=Y(MI,I)/DN
2270 TU=TU+U(I)*DI(I)+P(I)
2280 AU=AU+DI(I)/2
2290 SN=SN+AU*U(I)*DI(I)+P(I)*(AU+DI(I)/2)
2300 AU=AU+DI(I)/2
2310 NEXT I
2320 PR=FM(MI,2)-S2(6):PL=S2(3)-FM(MI,1):BM(0)=PL
2330 SR=(PR-SN-PL)/AL:SL=TU+SR:SB(1,1)=SL
2340 TR(1,1)=T1
2350 FOR I=1 TO NS(MI)
2360 SB(I,2)=SB(I,1)-U(I)*DI(I)
2370 CM=(SB(I,1)+SB(I,2))*DI(I)/2
2380 BM(I)=BM(I-1)+CM
2390 SB(I+1,1)=SB(I,2)-P(I)
2400 TR(I,2)=TR(I,1)+TB(I)*DI(I)
2410 TR(I+1,1)=TR(I,2)+P2(I)
2420 NEXT I
2430 PRINT "*** MEMBER NO. ";MI;"***  JOINT. NEAR = ";MK(MI,1);" JOINT FAR = ";MK(MI,2)
2440 PRINT "  X(NEAR)    Y(NEAR)    X(FAR)   Y(FAR)    M.NEAR     M.FAR"
2450 PRINT USING "##,###.## ";S2(1),S2(2),S2(4),S2(5),PL,PR
2460 PRINT "  THR(NEAR) THR(FAR) SHEAR NEAR  SHEAR FAR"
2470 PRINT USING "###,###.##";T1,T2,SL,SR
2480 IF NS(MI)<=1 THEN 2560 
2490 PRINT "SEGMENT VALUES"
2500 PRINT "SEG.  LENGTH    SH.NEAR  SH.FAR   MOM.RT  THR.NEAR  THR.FAR"
2510 FOR I= 1 TO NS(MI)
2520 PRINT USING "### ";I;
2530 PRINT USING "#,###.## ";DI(I),SB(I,1),SB(I,2),BM(I),TR(I,1),TR(I,2)
2540 NEXT I
2550 GOTO 2570 
2560 PRINT USING "MOM. 1/4 PT.= #####.##   MID.= #####.##   3/4= #####.##";CL,CC,CR
2570 IF INT(MI/3)=MI/3 THEN PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS
2580 PRINT
2590 RETURN
2600 '
2610 PRINT :PRINT "STATICS CHECK"
2620 FOR AI=1 TO N1:PRINT USING "##.#### "; F(AI);
2630 IF INT(AI/5)=AI/5 THEN PRINT
2640 NEXT 
2650 PRINT:PRINT:INPUT "<ENTER> TO CONTINUE WITH ITERATIONS OR <E> TO END ";A$:CLS
2660 IF A$="E" THEN END
2670 RETURN
2680 '
2690 FOR I=1 TO JF:KX=ND(I,1):KY=ND(I,2)
2700 CK(I,1)=DS(I,1)-D1(KX)/EL:CK(I,2)=DS(I,2)-D1(KY)/EL:NEXT
2710 PRINT "REVISED COORDINATES"
2720 PRINT "JOINT      X         Y"
2730 FOR I=1 TO JF:PRINT USING "### ";I;
2740 PRINT USING " ####.#### ";CK(I,1),CK(I,2)
2750 NEXT
2760 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS:PRINT
2770 RETURN
2780 '
2790 ' Stiffness Subroutine
2800 IF AV=0 THEN ET=1:GOTO 2820 
2810 ET=1/(1+36*XI/AL/AL/AV)
2820 DM=X/AL:DN=Y/AL
2830 AK=XI/AL:AA=(3*ET+1)*AK:S=A/AL:B=(3*ET-1)*AK:C=6*ET*AK/AL
2840 D=12*AK*ET/AL/AL
2850 F=S*DM*DM+D*DN*DN
2860 G=S*DM*DN-D*DM*DN
2870 P=S*DN*DN+D*DM*DM
2880 H=-C*DN:Q=C*DM
2890 IF IFLG=0 THEN 2900
2900 S1(1,1)= F:S1(1,2)= G:S1(1,3)= H
2910 S1(1,4)=-F:S1(1,5)=-G:S1(1,6)= H
2920 S1(2,1)= G:S1(2,2)= P:S1(2,3)= Q
2930 S1(2,4)=-G:S1(2,5)=-P:S1(2,6)= Q
2940 S1(3,1)= H:S1(3,2)= Q:S1(3,3)= AA
2950 S1(3,4)=-H:S1(3,5)=-Q:S1(3,6)= B
2960 S1(4,1)=-F:S1(4,2)=-G:S1(4,3)=-H
2970 S1(4,4)= F:S1(4,5)= G:S1(4,6)=-H
2980 S1(5,1)=-G:S1(5,2)=-P:S1(5,3)=-Q
2990 S1(5,4)= G:S1(5,5)= P:S1(5,6)=-Q
3000 S1(6,1)= H:S1(6,2)= Q:S1(6,3)= B
3010 S1(6,4)=-H:S1(6,5)=-Q:S1(6,6)= AA
3020 RETURN
3030 '
3040 ' Assemble matrix.
3050 FOR I=1 TO 6
3060 IF IR(I)=0 THEN 3150
3070 K=IR(I)
3080 FOR J=1 TO 6
3090 IF IR(J)=0 THEN 3140 
3100 L=IR(J)
3110 IF(K-L)>0 THEN 3140 
3120 L1=L-K+1
3130 S(K,L1)=S(K,L1)+S1(I,J)
3140 NEXT J
3150 NEXT I
3160 RETURN:
3170 '
3180 ' First part of solver
3190 PRINT "First part of equation solver - Count down."
3200 FOR N=1 TO N1
3210 FOR LL=2 TO IB
3220 C=S(N,LL)/S(N,1)
3230 I=N+LL-1
3240 IF (N1-I)<0 THEN 3320 
3250 J=0
3260 FOR K=LL TO IB
3270 J=J+1
3280 S(I,J)=S(I,J)-C*S(N,K)
3290 NEXT K
3300 S(N,LL)=C
3310 NEXT LL
3320 NEXT N
3330 PRINT
3340 RETURN
3350 '
3360  ' Second part of solver.
3370 PRINT:PRINT "Second part of equation solver. "
3380 FOR N=1 TO N1
3390 FOR LL=2 TO IB
3400 I=N+LL-1
3410 IF (N1-I)<0 THEN 3440 
3420 D1(I)=D1(I)-S(N,LL)*D1(N)
3430 NEXT LL
3440 D1(N)=D1(N)/S(N,1)
3450 NEXT N
3460 PRINT
3470 N=N1
3480 N=N-1
3490 IF (N)=0 THEN 3560 
3500 FOR K=2 TO IB
3510 LL=N+K-1
3520  IF(N1-LL)<0 THEN 3540 
3530 D1(N)=D1(N)-S(N,K)*D1(LL)
3540 NEXT K
3550 GOTO 3480 
3560 PRINT:PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS:PRINT
3570 RETURN
3580 '
3590 XX=1:FOR I=1 TO N1:F(I)=F3(I):D1(I)=F3(I):NEXT
3600 FOR I=1 TO N1:FOR J=1 TO IB:S(I,J)=0:NEXT J,I
3610 RETURN
3620 DATA TEST BUILDING FRAME
3630 '
4000 ' No. of members, no. of joints, value of E
4010 DATA 9,8,4.17E6
4020 ' Coordinates
4030 DATA 1,0,0, 2,30,0, 3,0,10, 4,30,10, 5,0,20, 6,30,20
4040 DATA 7,0,30, 6,30,30
4050 ' Member, area,I,shear area (zero) if not considered. (ZERO TO QUIT)
4060 DATA 1,.065,.00530,0, 2,.093,.03430,0, 0
4070 ' Member, from joint, to joint, member type.
4080 DATA 1,3,4,2, 2,5,6,2, 3,7,8,2, 4,1,3,1, 5,3,5,1, 6,5,7,1
4090 DATA 7,2,4,1, 8,4,6,1, 9,6,8,1
4100 ' Joint releases or supports. (zero for fixity, 1 to deflection)
4110 DATA 1,0,0,1, 2,0,0,1, 0
4120 '
4130 DATA 1, Lateral and Vertical
4140 ' No. of joint loads, No. of member loads
4150 DATA 3,3
4160 ' Joint loads: (Joint, X, Y, Moment)
4170 DATA 3,-4,0,0, 5,-4,0,0, 7,-4,0,0
4180 ' Uniform loads: (Member, X, Y)
4190 DATA 1,0,2, 2,0,2, 3,0,2
